function cost = sumCostGLOSA(allData,binstart,binend,phi, beta,alpha,lambda,zeta,q)
    %Calculates cost function to be used by CVX
    n = length(allData);
    cost = 0;
    for i = 1:n
       %dict = makeBinWBdict([-flip(binend) binstart],[-flip(binstart) binend], allData{i}.SamplingInstants);

       % Construct a WB dictionary
        DictBandStart = [-flip(binend(:)); binstart(:)]; DictBandEnd = [-flip(binstart(:));binend(:)]; T = allData{i}.SamplingInstants(:);
        % ff may be binned (such that it contains disconnected regions)
        % Do not divide by 0. 
        T = T-min(T)+.1;
        dict = (exp(2i*pi*DictBandEnd'.*T)-exp(2i*pi*DictBandStart'.*T))./2i./T;
        dict = dict./norms(dict);

       cost = cost + pow_pos(norm(allData{i}.y-dict*beta(:,i),2),2);

       cost = cost + zeta(i)*norm(q.*(phi-alpha(:,i)),1);
    end
    cost = cost + lambda*norm(phi,1);
end